class Fifo {
public:
	Fifo ( const char *arg_fifo_name, bool arg_for_writing = false )
	: for_writing(arg_for_writing) {
		if (for_writing)
			fd = open(arg_fifo_name,O_WRONLY);
		else
			fd = open(arg_fifo_name,O_RDONLY);
		if (fd == -1) System::perror("Fifo::Fifo: open()");
	}

	~Fifo () {
		close(fd);
	}

	void send ( char *arg_message, size_t arg_message_size ) {
		if (!for_writing) System::fatal("Fifo::send: no writing in fifo");
		while (arg_message_size > 0) {
			int ret = write(fd,arg_message,arg_message_size);
			if (ret == -1) System::perror("Fifo::send: write()");
			arg_message += ret;
			arg_message_size -= ret;
		}
	}

	void receive ( char *arg_buffer, size_t arg_message_size ) {
		if (for_writing) System::fatal("Fifo::send: no reading in fifo");
		while (arg_message_size > 0) {
			int ret = read(fd,arg_buffer,arg_message_size);
			if (ret == -1) System::perror("Fifo::receive: read()");
			arg_buffer += ret;
			arg_message_size -= ret;
		}
	}
private:
	int fd;
	bool for_writing;
};

